%Permalloy in plane FMR

clc;
clear all;
close all;
global w mu0 Qi1s Qi2s Qi3s k1s k2s k3s h1r h1l h2r h2l h3r h3l Z1s Z2s Z3s eps
g=2.1;
fourpiMs=10000;
%Hext=1103.3;
dH=30;
sigma=0.7e5;
A=1.14e-6;
mu0=4*pi*10^-9;
f=9.53e9;
e0=1/(36*pi)*10^-11;
gamma=g.*0.8805e7;
omega=2.*pi*f-j.*(dH.*0.924525e7);
w=omega;
topn=j.*fourpiMs.*w/gamma;
H0=10:1:3000;
L=length(H0);
H1=H0;
H2=H0+fourpiMs;
e=-j.*sigma./omega;
M=fourpiMs./(4.*pi);
k0=sqrt(omega.^2.*e.*mu0);

a1=1;
a2=(2.*H0+fourpiMs)./(2.*A./M)-k0.^2;
a3=(H0.*(H0+fourpiMs)-(omega./gamma).^2)./(4.*A.^2./M.^2)-2.*(H0+fourpiMs)./(2.*A./M).*k0.^2;
a4=((omega./gamma).^2-(H0+fourpiMs).^2)./(4.*A.^2./M.^2).*k0.^2;
a=a2;
b=a3;
c=a4;
[k1_sq,k2_sq,k3_sq]=solve3order(a,b,c);

k0_sq=-j.*omega.*sigma.*mu0;%k0squared

k1=-sign(imag(k1_sq)).*sqrt(k1_sq);
k2=-sign(imag(k2_sq)).*sqrt(k2_sq);

k3=-sign(imag(k3_sq)).*sqrt(k3_sq);


 figure(1);%k vs H
hold on;

plot(real(k1),H0,'b','Linewidth',2);
plot(imag(k1),H0,'b--','Linewidth',2);
plot(real(k2),H0,'r','Linewidth',2);
plot(imag(k2),H0,'r--','Linewidth',2);
plot(real(k3),H0,'g','Linewidth',2);
plot(imag(k3),H0,'g--','Linewidth',2);
% plot(H0,real(k3),'g','Linewidth',2);
% plot(H0,imag(k3),'g--','Linewidth',2);
% plot(H0,abs(real(k4)),'cyan','Linewidth',2);
% plot(H0,imag(k4),'cyan--','Linewidth',2);

ylabel('H0(Oe)','Fontsize',24);
%xlabel('Im(k) & Re(k) (cm^-^1)','Fontsize', 24);
xlabel('k(rad/cm)','Fontsize', 24);
%legend('Re(k)>0','Im(k)<0',2);
h = gca;
set(h,'Fontsize',22);
title('Permalloy Dispersion Diagram','FontSize',24);
hold off;

                                                     


% Calculating the surface impedance of a permalloy film with magnetization 
% Parallel to the plane. Theta_k = pi/2. 
% CGS units.
%clc;
%clear all;
%close all;

%global d V 
%global w mu0 eps Xi1s Xi2s Xi3s k1s k2s k3s Z1s Z2s Z3s h1r h1l h2r h2l h3r h3l


eps0 = 1/(36*pi)*10^-11; % F/cm
Z0 = sqrt(mu0/eps0);
eps = -j*sigma./w; % F/cm
Mu_r = 1+fourpiMs.*H2./(H1.*H2-(w./gamma)^2);



% Calculate the surface impedance, only consider resonant modes

d = 0.3E-4; % cm

Di1=(H1+2.*(A./M).*k1_sq).*(H2+2.*(A./M).*k1_sq)-(w./gamma).^2;
Di2=(H1+2.*(A./M).*k2_sq).*(H2+2.*(A./M).*k2_sq)-(w./gamma).^2;
Di3=(H1+2.*(A./M).*k3_sq).*(H2+2.*(A./M).*k3_sq)-(w./gamma).^2;
Xi1 = topn./Di1; 
Xi2 = topn./Di2; 
Xi3 = topn./Di3;
Qi1=(1-k1_sq./k0_sq);
Qi2=(1-k2_sq./k0_sq);
Qi3=(1-k3_sq./k0_sq);

Ks_0 = 0; Ks_d = 0;
n_minus_2pi=0;
n_plus_2pi=0;
indicator=1;
for i = 1:L

     S = [ 1 1 1 1 1 1; ...
         exp(-j*k1(i)*d) exp(j*k1(i)*d) ...
         exp(-j*k2(i)*d) exp(j*k2(i)*d) ...
         exp(-j*k3(i)*d) exp(j*k3(i)*d); ...
         Xi1(i)*(Ks_0+j*k1(i)*A) Xi1(i)*(Ks_0-j*k1(i)*A) ...
         Xi2(i)*(Ks_0+j*k2(i)*A) Xi2(i)*(Ks_0-j*k2(i)*A) ...
         Xi3(i)*(Ks_0+j*k3(i)*A) Xi3(i)*(Ks_0-j*k3(i)*A); ...
         Xi1(i)*(Ks_d+j*k1(i)*A)*exp(-j*k1(i)*d) Xi1(i)*(Ks_d-j*k1(i)*A)*exp(j*k1(i)*d) ...
         Xi2(i)*(Ks_d+j*k2(i)*A)*exp(-j*k2(i)*d) Xi2(i)*(Ks_d-j*k2(i)*A)*exp(j*k2(i)*d) ...
         Xi3(i)*(Ks_d+j*k3(i)*A)*exp(-j*k3(i)*d) Xi3(i)*(Ks_d-j*k3(i)*A)*exp(j*k3(i)*d); ...
         j.*k1(i)*Qi1(i) -j.*k1(i)*Qi1(i) ...
         j.*k2(i)*Qi2(i) -j.*k2(i)*Qi2(i) ...
         j.*k3(i)*Qi3(i) -j.*k3(i)*Qi3(i); ....
         j.*k1(i)*Qi1(i)*(exp(-j*k1(i)*d)) -j.*k1(i)*Qi1(i)*(exp(j*k1(i)*d)) ...
         j.*k2(i)*Qi2(i)*(exp(-j*k2(i)*d)) -j.*k2(i)*Qi2(i)*(exp(j*k2(i)*d)) ...
         j.*k3(i)*Qi3(i)*(exp(-j*k3(i)*d)) -j.*k3(i)*Qi3(i)*(exp(j*k3(i)*d))];
  %N=[1e-6 0 0 0 0 0; 0 1e-6 0 0 0 0; 0 0 1e-6 0 0 0; 0 0 0 1e-6 0 0; 0 0 0 0 1e-6 0; 0 0 0 0 0 1e-6];
    b = [1 1 0 0 0 0]'; % boundary condition
    %b=N*b;
    %S = N*S;
     h_vec(:,i) = inv(S)*b; 
  
    Z1(i) = k1(i)/(omega*eps);
    Z2(i) = k2(i)/(omega*eps);
    Z3(i) = k3(i)/(omega*eps);
    
    SP = [ Z1(i)*exp(-j*k1(i)*d) -Z1(i)*exp(j*k1(i)*d) ...
           Z2(i)*exp(-j*k2(i)*d) -Z2(i)*exp(j*k2(i)*d) ...
           Z3(i)*exp(-j*k3(i)*d) -Z3(i)*exp(j*k3(i)*d); ....
           exp(-j*k1(i)*d) exp(j*k1(i)*d) ...
           exp(-j*k2(i)*d) exp(j*k2(i)*d) ...
           exp(-j*k3(i)*d) exp(j*k3(i)*d); ...
           Xi1(i)*(Ks_0+j*k1(i)*A) Xi1(i)*(Ks_0-j*k1(i)*A) ...
           Xi2(i)*(Ks_0+j*k2(i)*A) Xi2(i)*(Ks_0-j*k2(i)*A) ...
           Xi3(i)*(Ks_0+j*k3(i)*A) Xi3(i)*(Ks_0-j*k3(i)*A); ...
           Xi1(i)*(Ks_d+j*k1(i)*A)*exp(-j*k1(i)*d) Xi1(i)*(Ks_d-j*k1(i)*A)*exp(j*k1(i)*d) ...
           Xi2(i)*(Ks_d+j*k2(i)*A)*exp(-j*k2(i)*d) Xi2(i)*(Ks_d-j*k2(i)*A)*exp(j*k2(i)*d) ...
           Xi3(i)*(Ks_d+j*k3(i)*A)*exp(-j*k3(i)*d) Xi3(i)*(Ks_d-j*k3(i)*A)*exp(j*k3(i)*d); ...
           j.*k1(i)*Qi1(i) -j.*k1(i)*Qi1(i) ...   
           j.*k2(i)*Qi2(i) -j.*k2(i)*Qi2(i) ...
           j.*k3(i)*Qi3(i) -j.*k3(i)*Qi3(i); ....
           j.*k1(i)*Qi1(i)*(exp(-j*k1(i)*d)) -j.*k1(i)*Qi1(i)*(exp(j*k1(i)*d)) ...
           j.*k2(i)*Qi2(i)*(exp(-j*k2(i)*d)) -j.*k2(i)*Qi2(i)*(exp(j*k2(i)*d)) ...
           j.*k3(i)*Qi3(i)*(exp(-j*k3(i)*d)) -j.*k3(i)*Qi3(i)*(exp(j*k3(i)*d))];
        
       % SP = N*SP;
     
    B_mat=B_matrix(SP, Z1(i), Z2(i), Z3(i));  
    a11(i)=B_mat(1, 1);
    D=B_mat(1, 1)*B_mat(2, 2)-B_mat(1, 2)*B_mat(2, 1);
    Z_square=B_mat(1, 2)/B_mat(2, 1);
    Z(i)=sqrt(Z_square); 
    

   
      % calculation of alpha and beta: keff=beta+jalpha 
     
     ZS(i)=(B_mat(1,1)-1)/B_mat(2,1);
    emcoupl(i)=(ZS(i))/Z(i);
    C(i)= B_mat(1,1)+(B_mat(1,2))/Z(i);%1/S21,matched imp.
    %C=exp(jwt)=1/S21(S11=0)
     thet(i)=angle(C(i));
     beta(i)=thet(i)/d;
     alpha(i)=-log(abs(C(i)))/d;
   % if beta(i)>0
    %    beta(i)=-2*pi/d+beta(i);
     %   end

      if real(C(i))<0
      R(i)=imag(C(i))/real(C(i));
      beta(i)=-atan(R(i))/d;
      end
     
     keff(i)=beta(i)+j*alpha(i);
   

      
        emcoupl(i)=j*tan(keff(i)*(d/2));
     %    emcoupl(i)=ZS(i)/Z(i);
  %  ZS(i)=j.*Z(i)*tan(keff(i)*(d/2));
 %   ZS(i)=B_mat(1,1);
   Mueff(i)=(keff(i)*Z(i))/(w.*mu0);
  
    epseff(i)=(keff(i))/(Z(i)*w);
   
     sigma_eff = epseff.*j.*w;
      Zeff(i)=sqrt((Mueff(i)*mu0)./epseff(i));
     Zs_0(i) = Z1(i)*(h_vec(1,i)-h_vec(2,i)) + Z2(i)*(h_vec(3,i)-h_vec(4,i))+ Z3(i)*(h_vec(5,i)-h_vec(6,i));
     Zs_d(i) = Z1(i)*(h_vec(1,i)*exp(-j*k1(i)*d)-h_vec(2,i)*exp(j*k1(i)*d)) + Z2(i)*(h_vec(3,i)*exp(-j*k2(i)*d)-h_vec(4,i)*exp(j*k2(i)*d))+...
               Z3(i)*(h_vec(5,i)*exp(-j*k3(i)*d)-h_vec(6,i)*exp(j*k3(i)*d));
   
     % Check the result by integrating the poynting vector.
     Qi1s = Qi1(i); Qi2s = Qi2(i); Qi3s=Qi3(i) ;k1s = k1(i); k2s = k2(i); k3s=k3(i); Z1s = Z1(i); Z2s = Z2(i);Z3s=Z3(i);
    h1r = h_vec(1,i); h1l = h_vec(2,i); h2r = h_vec(3,i); h2l = h_vec(4,i); h3r=h_vec(5,i);h3l=h_vec(6,i);
     
 
    Integ(i) = quadgk(@myfun4,0,d);  % 2Zs(i)
   Integ1(i) = quadgk(@myfun5,0,d)/d; % Effective permeability by volume integration
 %   Integ2(i) = quadgk(@myfun6,0,d)/(Integ(i)/2)^2/d; % Effective permittivity by volume integration
 % Integ3(i) = quadgk(@myfun3,0,d);
    Integ2(i) = quadgk(@myfun6,0,d)/d;
  
end

figure(2);%char. impedance,Z, vs H (circ. pol.)
hold on;
 
plot(H0,real(Z),'r','Linewidth',2);
plot(H0,imag(Z),'r--','Linewidth',2);

% plot(H0, -real(Integ/2),'b','LineWidth',1);
% plot(H0, -imag(Integ/2),'b--','LineWidth',1);

xlabel('H(Oe)','Fontsize',24);
ylabel('Zeff(Ohm)','Fontsize', 24);

% axis([2500 4500 -100 100]);
h = gca;
set(h,'Fontsize',22);
title('characteristic impedance of 0.3 \mum Permalloy Film','FontSize',24);
legend('Zeff Real','Zeff Imag',2);
% legend('y = 0 Real','y = 0 Imag','y = d Real','y = d Imag','Integ Real', 'Integ Imag',4);
hold off;
figure(3);%effective k vs H (calc. from 2x2 matrix)
hold on;
plot(real(keff),H0,'r','Linewidth',2);
plot(imag(keff),H0,'r--','Linewidth',2);
ylabel('H(Oe)','Fontsize',24);
xlabel('keff(rad/cm)','Fontsize', 24);
h = gca;
set(h,'Fontsize',22);
title('Propogation constant of 0.3 \mum Permalloy Film','FontSize',24);
legend('keff real','keff imag',2);
hold off;

%figure(3);%effective k vs H (calc. from 2x2 matrix)
%hold on;
%plot(H0,beta,'r','Linewidth',2);
%plot(H0,alpha,'r--','Linewidth',2);
%xlabel('H(Oe)','Fontsize',24);
%ylabel('k(rad/cm)','Fontsize', 24);
%h = gca;
%set(h,'Fontsize',22);hold off;

%title('Propogation constant of 0.3 \mum Permalloy Film','FontSize',24);
%legend('beta','alpha',2);

figure(4);% surface impedance ,Zs, vs H (from 4x4 matrix)
hold on;

 plot(H0, real(Zs_0),'r','Linewidth',2);
 plot(H0, imag(Zs_0),'r--','Linewidth',2);

% plot(Ho,phi,'r','Linewidth',2);

xlabel('H(Oe)','Fontsize',24);
ylabel('Zs(Ohm)','Fontsize', 24);
h = gca;
set(h,'Fontsize',22);
title('Zs_0 of 0.3 \mum Permalloy Film','FontSize',24);
legend('real','Imag',2);
hold off;

figure (5);%surface impedance,ZS,vs H (from 2x2 matrix)
hold on;
 plot(H0,real(ZS),'b','Linewidth',2);
 plot(H0,imag(ZS),'b--','Linewidth',2);
 
 xlabel('H(Oe)','Fontsize',24);
ylabel('ZS(Ohm)','Fontsize', 24);
h = gca;
set(h,'Fontsize',22);
title('ZS of 0.3 \mum Permalloy Film','FontSize',24);
legend('real','Imag',2);
hold off;

figure(6);%mueff vs H (from poynting vector;mu vs H(from tensor mu)
hold on;
plot(H0, real(Mueff),'b','LineWidth',1);
plot(H0, -imag(Mueff),'b--', 'LineWidth',1);
%plot(H0, real(Integ1),'b','LineWidth',1);
%plot(H0, imag(Integ1),'b--', 'LineWidth',1);
xlabel('H(Oe)', 'FontSize', 24);
ylabel('mueff', 'FontSize',24);
%legend('Mueff Real','Mueff Imag','MuS Real','MuS Imag',1);
h = gca;
set(h,'Fontsize',22);
title('Permeability ','FontSize',24);
hold off;
ZSM2=(abs(Zs_0)).^2;
MuS=mu0*Integ1;
epsS=Integ2./ZSM2;
sigmaS=epsS.*(j.*w);

figure(7);%epseff vs H (from poynting vector)
hold on;
plot(H0, real(epseff),'b','LineWidth',2);
plot(H0, imag(epseff),'b--', 'LineWidth',2);
xlabel('H(Oe)', 'FontSize', 24);
ylabel('\epsilon_e_f_f(f/cm)', 'FontSize',32);
legend('\epsilon_e_f_f Real','\epsilon_e_f_f Imag',4);
h = gca;
set(h,'Fontsize',30);
title('Effective Average Permittivity','FontSize',24);
hold off;

figure(8);
hold on;
plot(H0, real(sigma_eff),'LineWidth',2);
plot(H0, imag(sigma_eff),'r--','LineWidth',2);
plot(H0, sigma,'r','LineWidth',2);
h = gca;
set(h,'Fontsize',30);
hold off;
xlabel('H(Oe)', 'FontSize', 30);
ylabel('sigma_e_f_f(mhos/cm)', 'FontSize',32);
title('Effective conductivity','FontSize',30);
legend('sigma_e_f_f Real','sigma_e_f_f Imag',4);

figure(9);%Zeff vs H (calculated from sqrt(mu0*mueff/epseff)
hold on;
plot(H0, real(Zeff),'LineWidth',2);
plot(H0, imag(Zeff),'r','LineWidth',2);
h = gca;
set(h,'Fontsize',30);
hold off;
xlabel('H(Oe)', 'FontSize', 30);
ylabel('Z_e_f_f(Ohm)', 'FontSize',32);
title('Z_e_f_f','FontSize',30);
legend('Z_e_f_f Real','Z_e_f_f Imag',4);


ZSM2=(abs(Zs_0)).^2;
 MuS=mu0*Integ1;

%epsS=-2.*Zs_0./(j.*w.*ZSM2.*d)+MuS./ZSM2;
 epsS=Integ2./ZSM2;
%epsS=conj(epsS);
sigmaS = epsS.*j.*w;
 Zsv=0.5.*(j.*w.*d.*(MuS-(conj(epsS).*ZSM2)));% also, Zs

figure(10);%epsS vs H (from poynting vector)
hold on;
plot(H0, real(epsS),'b','LineWidth',2);
plot(H0, imag(epsS),'b--', 'LineWidth',2);
xlabel('H(Oe)', 'FontSize', 24);
ylabel('epsS(f/cm)', 'FontSize',32);
legend('epsS Real','epsS Imag',4);
h = gca;
set(h,'Fontsize',30);
title('Surface Average Permittivity','FontSize',24);
hold off;
figure(11);%sigmaS vs H (see fig. 7)
hold on;
plot(H0, real(sigmaS),'b','LineWidth',2);
plot(H0, imag(sigmaS),'r--','LineWidth',2);
plot(H0, sigmaS,'r','LineWidth',2);
h = gca;
set(h,'Fontsize',30);
hold off;
xlabel('H(Oe)', 'FontSize', 30);
ylabel('sigmaS(mhos/cm)', 'FontSize',32);
title('Surface conductivity','FontSize',30);
legend('sigmaS Real','sigmaS Imag',4);

figure(12);%Zsv vs H (calculated from poynting integral)
hold on;
%plot(H0, real(Zsv),'LineWidth',2);
%plot(H0, imag(Zsv),'r','LineWidth',2);
plot(H0, real(Integ1),'LineWidth',2);
plot(H0, -imag(Integ1),'r','LineWidth',2);

h = gca;
set(h,'Fontsize',30);
hold off;
xlabel('H(Oe)', 'FontSize', 30);
ylabel('MuS', 'FontSize',32);
title('MuS','FontSize',30);
legend('MuS Real','MuS Imag',4);

figure(13);%emcoupl(i)
hold on;
plot(H0, real(emcoupl),'b','LineWidth',2);
plot(H0, imag(emcoupl),'b--', 'LineWidth',2);
xlabel('H(Oe)', 'FontSize', 24);
ylabel('emcoupl)', 'FontSize',32);
legend('emcoupl real','emcoupl Imag',4);
h = gca;
set(h,'Fontsize',30);
title('em coupling','FontSize',24);
hold off;


% % Plot out the h(y) at Ho = 2500 Oe. 
% 
% N = 501;
% 
% y = 0:d/200:d;
% hy = h_vec(1,N)*exp(-j*k1(N)*y) + h_vec(2,N)*exp(j*k1(N)*y) + h_vec(3,N).*exp(-j*k2(N)*y) + h_vec(4,N).*exp(j*k2(N)*y);
% 
% figure(3);
% hold on;
% plot(y,real(hy),'LineWidth',2);
% % plot(y,imag(hy),'g','LineWidth',2);
% % plot(y,abs(hy),'r','LineWidth',2);
% h = gca;
% set(h,'Fontsize',30);
% % axis([0 d 0.8 1]);
% xlabel('y(cm)','Fontsize',30);
% ylabel('Re(h(y))','Fontsize',30);
% title(['Ho = ', num2str(Ho(N)), 'Oe'],'Fontsize',30);
% hold off;

% X. Save raw data file for figure 1%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

% % Plot out the h(y) at Ho = 2500 Oe. 
% 
% N = 501;
% 
% y = 0:d/200:d;
% hy = h_vec(1,N)*exp(-j*k1(N)*y) + h_vec(2,N)*exp(j*k1(N)*y) + h_vec(3,N).*exp(-j*k2(N)*y) + h_vec(4,N).*exp(j*k2(N)*y);
% 
% figure(3);
% hold on;
% plot(y,real(hy),'LineWidth',2);
% % plot(y,imag(hy),'g','LineWidth',2);
% % plot(y,abs(hy),'r','LineWidth',2);
% h = gca;
% set(h,'Fontsize',30);
% % axis([0 d 0.8 1]);
% xlabel('y(cm)','Fontsize',30);
% ylabel('Re(h(y))','Fontsize',30);
% title(['Ho = ', num2str(Ho(N)), 'Oe'],'Fontsize',30);
% hold off;

