%Permalloy in plane FMR

function A=cavity_response(H0, f)
global w mu0 Qi1s Qi2s Qi3s k1s k2s k3s h1r h1l h2r h2l h3r h3l Z1s Z2s Z3s eps d
g=2.1;
fourpiMs=10000;
%Hext=1103.3;
dH=30;
sigma=0.7e5;
A=1.14e-6;
mu0=4*pi*10^-9;
%f=10.290e9;
e0=1/(36*pi)*10^-11;
gamma=g.*0.8805e7;
omega=2.*pi*f-j.*(dH.*0.924525e7);
w=omega;
topn=j.*fourpiMs.*w/gamma;
%H0=10:1:3000;

H1=H0;
H2=H0+fourpiMs;
e=-j.*sigma./omega;
M=fourpiMs./(4.*pi);
k0=sqrt(omega.^2.*e.*mu0);

a1=1;
a2=(2.*H0+fourpiMs)./(2.*A./M)-k0.^2;
a3=(H0.*(H0+fourpiMs)-(omega./gamma).^2)./(4.*A.^2./M.^2)-2.*(H0+fourpiMs)./(2.*A./M).*k0.^2;
a4=((omega./gamma).^2-(H0+fourpiMs).^2)./(4.*A.^2./M.^2).*k0.^2;
a=a2;
b=a3;
c=a4;
[k1_sq,k2_sq,k3_sq]=solve3order(a,b,c);

k0_sq=-j.*omega.*sigma.*mu0;%k0squared

k1=-sign(imag(k1_sq)).*sqrt(k1_sq);
k2=-sign(imag(k2_sq)).*sqrt(k2_sq);

k3=-sign(imag(k3_sq)).*sqrt(k3_sq);




                                                     


% Calculating the surface impedance of a permalloy film with magnetization 
% Parallel to the plane. Theta_k = pi/2. 
% CGS units.
%clc;
%clear all;
%close all;

%global d V 
%global w mu0 eps Xi1s Xi2s Xi3s k1s k2s k3s Z1s Z2s Z3s h1r h1l h2r h2l h3r h3l


eps0 = 1/(36*pi)*10^-11; % F/cm
Z0 = sqrt(mu0/eps0);
eps = -j*sigma./w; % F/cm
Mu_r = 1+fourpiMs.*H2./(H1.*H2-(w./gamma)^2);



% Calculate the surface impedance, only consider resonant modes

%d = 0.3E-4; % cm

Di1=(H1+2.*(A./M).*k1_sq).*(H2+2.*(A./M).*k1_sq)-(w./gamma).^2;
Di2=(H1+2.*(A./M).*k2_sq).*(H2+2.*(A./M).*k2_sq)-(w./gamma).^2;
Di3=(H1+2.*(A./M).*k3_sq).*(H2+2.*(A./M).*k3_sq)-(w./gamma).^2;
Xi1 = topn./Di1; 
Xi2 = topn./Di2; 
Xi3 = topn./Di3;
Qi1=(1-k1_sq./k0_sq);
Qi2=(1-k2_sq./k0_sq);
Qi3=(1-k3_sq./k0_sq);

Ks_0 = 0; Ks_d = 0;
n_minus_2pi=0;
n_plus_2pi=0;
indicator=1;


     S = [ 1 1 1 1 1 1; ...
         exp(-j*k1*d) exp(j*k1*d) ...
         exp(-j*k2*d) exp(j*k2*d) ...
         exp(-j*k3*d) exp(j*k3*d); ...
         Xi1*(Ks_0+j*k1*A) Xi1*(Ks_0-j*k1*A) ...
         Xi2*(Ks_0+j*k2*A) Xi2*(Ks_0-j*k2*A) ...
         Xi3*(Ks_0+j*k3*A) Xi3*(Ks_0-j*k3*A); ...
         Xi1*(Ks_d+j*k1*A)*exp(-j*k1*d) Xi1*(Ks_d-j*k1*A)*exp(j*k1*d) ...
         Xi2*(Ks_d+j*k2*A)*exp(-j*k2*d) Xi2*(Ks_d-j*k2*A)*exp(j*k2*d) ...
         Xi3*(Ks_d+j*k3*A)*exp(-j*k3*d) Xi3*(Ks_d-j*k3*A)*exp(j*k3*d); ...
         j.*k1*Qi1 -j.*k1*Qi1 ...
         j.*k2*Qi2 -j.*k2*Qi2 ...
         j.*k3*Qi3 -j.*k3*Qi3; ....
         j.*k1*Qi1*(exp(-j*k1*d)) -j.*k1*Qi1*(exp(j*k1*d)) ...
         j.*k2*Qi2*(exp(-j*k2*d)) -j.*k2*Qi2*(exp(j*k2*d)) ...
         j.*k3*Qi3*(exp(-j*k3*d)) -j.*k3*Qi3*(exp(j*k3*d))];
  %N=[1e-6 0 0 0 0 0; 0 1e-6 0 0 0 0; 0 0 1e-6 0 0 0; 0 0 0 1e-6 0 0; 0 0 0 0 1e-6 0; 0 0 0 0 0 1e-6];
    b = [1 1 0 0 0 0]'; % boundary condition
    %b=N*b;
    %S = N*S;
     h_vec = inv(S)*b; 
  
    Z1 = k1/(omega*eps);
    Z2 = k2/(omega*eps);
    Z3 = k3/(omega*eps);
    
    SP = [ Z1*exp(-j*k1*d) -Z1*exp(j*k1*d) ...
           Z2*exp(-j*k2*d) -Z2*exp(j*k2*d) ...
           Z3*exp(-j*k3*d) -Z3*exp(j*k3*d); ....
           exp(-j*k1*d) exp(j*k1*d) ...
           exp(-j*k2*d) exp(j*k2*d) ...
           exp(-j*k3*d) exp(j*k3*d); ...
           Xi1*(Ks_0+j*k1*A) Xi1*(Ks_0-j*k1*A) ...
           Xi2*(Ks_0+j*k2*A) Xi2*(Ks_0-j*k2*A) ...
           Xi3*(Ks_0+j*k3*A) Xi3*(Ks_0-j*k3*A); ...
           Xi1*(Ks_d+j*k1*A)*exp(-j*k1*d) Xi1*(Ks_d-j*k1*A)*exp(j*k1*d) ...
           Xi2*(Ks_d+j*k2*A)*exp(-j*k2*d) Xi2*(Ks_d-j*k2*A)*exp(j*k2*d) ...
           Xi3*(Ks_d+j*k3*A)*exp(-j*k3*d) Xi3*(Ks_d-j*k3*A)*exp(j*k3*d); ...
           j.*k1*Qi1 -j.*k1*Qi1 ...   
           j.*k2*Qi2 -j.*k2*Qi2 ...
           j.*k3*Qi3 -j.*k3*Qi3; ....
           j.*k1*Qi1*(exp(-j*k1*d)) -j.*k1*Qi1*(exp(j*k1*d)) ...
           j.*k2*Qi2*(exp(-j*k2*d)) -j.*k2*Qi2*(exp(j*k2*d)) ...
           j.*k3*Qi3*(exp(-j*k3*d)) -j.*k3*Qi3*(exp(j*k3*d))];
        
       % SP = N*SP;
     
    A=B_matrix(SP, Z1, Z2, Z3);  

    

   
  

